<!DOCTYPE html>
<html
	xmlns:th="http://www.thymeleaf.org"
	xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
	layout:decorate="~{layouts/admin.html}"
>
	<head>
		<title layout:title-pattern="$CONTENT_TITLE - $LAYOUT_TITLE">
			Setting - Faculty
		</title>
		<meta name="_csrf" th:content="${_csrf.token}"/>
		<meta name="_csrf_header" th:content="${_csrf.headerName}"/>
		<script th:inline="javascript">
			function editFaculty(id,institution,status,department,name){
				document.getElementById('id').value = id;
				document.getElementById('institution').value = institution;
				document.getElementById('department').value = department;
				document.getElementById('facultyName').value = name;
				document.getElementById('cancel-button').style.display = 'block';
				loadDepartments(department);

			}

			function cancelEdit() {
				document.getElementById('id').value = '';
				document.getElementById('institution').value = '';
				document.getElementById('department').value = '';
				document.getElementById('facultyName').value = '';
				document.getElementById('cancel-button').style.display = 'none';
			}

			async function updateStatus(id, status){
				const csrfToken = document.querySelector('meta[name="_csrf"]').getAttribute('content');
				const csrfHeader = document.querySelector('meta[name="_csrf_header"]').getAttribute('content');

				try {
					const response = await fetch(`/setting/faculty/${id}`, {
						method: 'PUT',
						headers: {
							'Content-Type': 'application/json',
							[csrfHeader]: csrfToken
						},
						body: JSON.stringify({ id: id, status: status ? 'ACTIVE' : 'INACTIVE' }),
					});

					if (!response.ok) {
						throw new Error('Failed to update status');
					}
				} catch (error) {
					console.error(error);
					// Optionally revert the checkbox state if the update failed
					document.querySelector(`input[data-id='${id}']`).checked = !status;
				}

			}

			function loadDepartments(selectedDepartment) {
				var institutionId = document.getElementById('institution').value;
				var departmentSelect = document.getElementById('department');

				departmentSelect.innerHTML = '<option value="">Pilih Departemen</option>';

				if (institutionId) {
					fetch('/setting/get-department/' + institutionId)
							.then(response => response.json())
							.then(result => {
								var departments = result.data;
								if (Array.isArray(departments)) {
									departments.forEach(department => {
										var option = document.createElement('option');
										option.value = department.id;
										option.text = department.departmentName;
										departmentSelect.add(option);
									});

									if (selectedDepartment) {
										departmentSelect.value = selectedDepartment;
									}
								} else {
									console.error('Expected an array but got:', departments);
								}
							})
							.catch(error => console.error('Error fetching departments:', error));
				}
			}

			function changeFacultyName() {
				var departmentSelect = document.getElementById('department');
				var facultyNameInput = document.getElementById('facultyName');

				var selectedOption = departmentSelect.options[departmentSelect.selectedIndex];
				if (facultyNameInput.value == ''){
					facultyNameInput.value =selectedOption.text;
				}
			}
		</script>
	</head>
	<body layout:fragment="content">
		<div class="container mx-auto px-4 mb-6 mt-6 space-y-6">
			<!-- nav tabs -->
			<div th:replace="~{setting/faculty/partials/navtab.html :: navTab}"></div>

			<!-- form -->
			<div th:replace="~{setting/faculty/partials/form.html :: form}"></div>
			<div class="rounded-xl shadow bg-white dark:bg-gray-800">
				<!-- table header -->
				<div
					th:replace="~{setting/faculty/partials/table-header.html :: tableHeader}"
				></div>
				<!-- table -->
				<div th:replace="~{setting/faculty/partials/table.html :: table}"></div>
				<!-- table footer -->
				<div
					th:replace="~{setting/faculty/partials/table-footer.html :: tableFooter}"
				></div>
			</div>
		</div>
	</body>
</html>
